#!/bin/sh
#Program:
#	This script is used to build a USB network
#History:
#	2018/10/25	Luyj	Frist release
export PATH="$PATH:/mnt/platform/bin:/mnt/platform/sbin"
export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:/mnt/platform/lib"

g_multi_install(){
	if test -b /dev/mmcblk1 		#install USB g_multi
	then
	echo "emmc is at mmcblk1, and now will insmod USB g_multi "
	modprobe g_multi file=/dev/mmcblk1p1,/mnt/p1/static.img, luns=2 ro=0,1 stall=0,0 removable=1,1 iSerialNumber=3000111 iProduct=zhdgnss
	else
	echo "emmc is at mmcblk0, and now will insmod USB g_multi "
	modprobe g_multi file=/dev/mmcblk0p1,/mnt/p1/static.img, luns=2 ro=0,1 stall=0,0 removable=1,1 iSerialNumber=3000111 iProduct=zhdgnss
	fi
}


udhcpd_usb(){
	#get udhcpd_usb* PID
	USB_NET_PID=$(ps -ef | grep "udhcpd_usb" | grep -v "grep" | awk '{print $1}')
	if [ -n "${USB_NET_PID}" ]; then
		echo "the udhcpd is running ! "
	else
		echo "Now open the udhcpd service!"

		ifconfig -a | grep "usb1"

		if [ $? -eq 0 ]
		then
		/etc/udhcpd_usb1
		else
		/etc/udhcpd_usb0
		fi	
		echo "udhcpd service done!"	
	fi
}

setup_telnet(){
	telnetd
	usleep 10000
	udhcpd_usb
}

start_usb_network(){
	#find g_mass_storage
	lsmod | grep "g_mass_storage"

	if [ $? -eq 0 ]				#
	then
		rmmod g_mass_storage	#remove g_mass_storage 
		g_multi_install			#install g_multi
		setup_telnet
	else
		lsmod | grep "g_multi"	

		if [ $? -eq 0 ];then
			echo "the g_multi.ko is already installed, now will turn on the usb_network service."
			setup_telnet
		else
			g_multi_install
			setup_telnet
		fi
	fi
	echo "usb network service done!"	
}

stop_usb_network(){
	#get udhcpd_usb* PID
	USB_NET_PID=$(ps -ef | grep "udhcpd_usb" | grep -v "grep" | awk '{print $1}')
	if [ -n "${USB_NET_PID}" ]; then
		echo "now stop usb network service!"
		kill -9 ${USB_NET_PID}
		rm -f /vat/run/udhcpd_usb*
		if [ $? -eq 0 ]; then
			echo "stop usb network successed!"
		fi
	else
		echo "No fount usb network service!"
	fi
}

case $1 in
	start)
		start_usb_network
	;;
	stop)
		stop_usb_network
	;;
	restart)
		$0 stop
		sleep 1
		$0 start	
	;;
	*)
		echo "Usage: $0 start | stop | restart"
esac

